from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Float

Anvi_Script_Process_Genbank_V0_1_0 = CommandToolBuilder(tool="anvi_script_process_genbank", base_command=["anvi-script-process-genbank"], inputs=[ToolInput(tag="in_input_genbank", input_type=File(optional=True), prefix="--input-genbank", doc=InputDocumentation(doc="Input GenBank file")), ToolInput(tag="in_output_file_prefix", input_type=File(optional=True), prefix="--output-file-prefix", doc=InputDocumentation(doc="A prefix to be used while naming the output files (no\nfile type extensions please; just a prefix).")), ToolInput(tag="in_output_fast_a", input_type=File(optional=True), prefix="--output-fasta", doc=InputDocumentation(doc="Output FASTA file path.")), ToolInput(tag="in_output_gene_calls", input_type=File(optional=True), prefix="--output-gene-calls", doc=InputDocumentation(doc="DELIMITED FILE\nOutput file path for external gene calls")), ToolInput(tag="in_output_functions", input_type=File(optional=True), prefix="--output-functions", doc=InputDocumentation(doc="DELIMITED FILE\nOutput file path for anvi'o-importable gene functions\nfile")), ToolInput(tag="in_annotation_source", input_type=String(optional=True), prefix="--annotation-source", doc=InputDocumentation(doc="Annotation source (default: 'NCBI_PGAP')")), ToolInput(tag="in_annotation_version", input_type=Float(optional=True), prefix="--annotation-version", doc=InputDocumentation(doc="Annotation source version to be stored in the database\n(default: 'v4.6')\n"))], outputs=[ToolOutput(tag="out_output_file_prefix", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file_prefix", type_hint=File()), doc=OutputDocumentation(doc="A prefix to be used while naming the output files (no\nfile type extensions please; just a prefix).")), ToolOutput(tag="out_output_fast_a", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_fast_a", type_hint=File()), doc=OutputDocumentation(doc="Output FASTA file path.")), ToolOutput(tag="out_output_gene_calls", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_gene_calls", type_hint=File()), doc=OutputDocumentation(doc="DELIMITED FILE\nOutput file path for external gene calls")), ToolOutput(tag="out_output_functions", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_functions", type_hint=File()), doc=OutputDocumentation(doc="DELIMITED FILE\nOutput file path for anvi'o-importable gene functions\nfile"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Script_Process_Genbank_V0_1_0().translate("wdl", allow_empty_container=True)

